// BAS_DMO1 (c) 1999 Jger Messtechnik GmbH
// 30.04.99
// Delphi 2.0
unit BAS_DMO1_;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TFormPar = class(TForm)
    Panel1: TPanel;
    Edit_Min: TEdit;
    Label7: TLabel;
    Edit_Max: TEdit;
    Label1: TLabel;
    BBQuit: TBitBtn;
    BBStart: TBitBtn;
    BBStop: TBitBtn;
    Timer1: TTimer;
    procedure BBQuitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BBStartClick(Sender: TObject);
    procedure BBStopClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FormPar: TFormPar;

implementation

uses uadwin;

{$R *.DFM}


const PAR_MIN   = 1;                // Minvalue
      PAR_MAX   = 2;                // Maxvalue
      btlpath = 'c:\ADBASIC3\';     // path for btl-file
//      btlfile = 'adwin4.btl';     // btl-file depends on ADwin-System
//      btlfile = 'adwin5.btl';
//      btlfile = 'adwin8.btl';
      btlfile = 'adwin9.btl';
//      size = 100000;              // size of memory depends on ADwin-System
      size = 400000;
//      size = 800000;

//       process = 'BAS_DMO1.t41';  // binary file depends on ADwin-System
//       process = 'BAS_DMO1.t51';
//       process = 'BAS_DMO1.t81';
       process = 'BAS_DMO1.t91';




procedure TFormPar.BBQuitClick(Sender: TObject);
begin
  Close;  // end program
end;

procedure TFormPar.FormCreate(Sender: TObject);
var directory : String;
begin
  if Boot(btlpath+btlfile,size)<>1 then Timer1.enabled := TRUE;             // boot ADwin-System
  directory:=extractfilepath(Paramstr(0)); // path of the program
  ADBload(directory+process);              // load process
end;

procedure TFormPar.BBStartClick(Sender: TObject);
begin
  BBStop.Enabled  := True;
  BBStart.Enabled := False;
  Start(1);                                // start process
end;

procedure TFormPar.BBStopClick(Sender: TObject);
begin
  BBStop.Enabled  := False;
  BBStart.Enabled := True;
  Stop(1);                                 // stop process
end;

procedure TFormPar.FormDestroy(Sender: TObject);
begin
  Stop(1);                                 // stop process
end;

procedure TFormPar.Timer1Timer(Sender: TObject);
var min,max : Word;
begin
  if get_activate(1)>0 then begin  // if the measurement on the ADwin-System is finish
    min:=get_par(PAR_MIN);         // show values
    max:=get_par(PAR_MAX);
    Edit_Min.Text:=Format('%6d',[min]);
    Edit_Max.Text:=Format('%6d',[max]);
  end;
end;

end.
