Rem Sammlung von Unterprogrammen zur Steuerung der ADwin-Messwerterfassungs-
Rem karten aus VISUAL-BASIC
Rem Version 1.3 H.Jger 03/95

Rem 1. Linkkommunikationsfunktionen der DLL ADwin
Rem ==============================================
Rem Achtung! die Datei "ADWIN.DLL" mu in einem Subdirectory stehen, das
Rem Windows findet ( am besten in " \windows")
Rem Um diese Funktionen nutzen zu knnen mu vorher das Programm
Rem "ADwin8.btl" (bzw. ADwin2.btl oder ADwin4.btl) auf die ADwin-Karte
Rem geladen werden!

Rem Die DLL ADwin.dll enthlt die Funktionen zum Datenaustausch zwischen dem
Rem PC und dem Transputer auf der ADwin-Karte.
Rem To_link sendet 1 Byte an den Transputer.To_link2 sendet 2 und to_link4 4.
Rem Entspechend holen die from_link Funktionen Daten vom Transputer ab.
Declare Function to_link Lib "adwin.dll" (ByVal ladr%, ByVal iw%) As Integer
Declare Function to_link2 Lib "adwin.dll" (ByVal ladr%, ByVal iw%) As Integer
Declare Function to_link4 Lib "adwin.dll" (ByVal ladr%, ByVal iw&) As Integer
Declare Function to_linkf Lib "adwin.dll" (ByVal ladr%, ByVal iw!) As Integer
Declare Function from_link Lib "adwin.dll" (ByVal ladr%) As Integer
Declare Function from_link2 Lib "adwin.dll" (ByVal ladr%) As Integer
Declare Function from_link4 Lib "adwin.dll" (ByVal ladr%) As Long
Declare Function from_linkf Lib "adwin.dll" (ByVal ladr%) As Single
Declare Function starte Lib "adwin.dll" (ByVal dateiname As String, ByVal Linkaddress As Integer) As Integer
Declare Function iserver Lib "adwin.dll" (ByVal dateiname As String, ByVal Linkaddress As Integer, ByVal iboardsize As Long) As Integer

Rem Default Linkadresse auf 0x150 setzen:
Global Const linkadr% = 336

Rem berprft ob der Prozess "PNo%" den Befehl Activate_PC
Rem ausgefhrt hat
Function Activate (PNo%) As Long
  id% = to_link(linkadr%, 38)
  id% = to_link2(linkadr%, PNo% + 930)
  erg% = from_link4(linkadr%)
  Activate = erg%
  If erg% = 1 Then
    id% = to_link(linkadr%, 34)
    id% = to_link2(linkadr%, PNo% + 930)
    id% = to_link4(linkadr%, 0)
  End If
End Function

Rem Ld ein ADbasic-Prozess (von ADbasic erzeugtes Bin File) auf die ADwin-Karte
Sub adbload (adbasicfile$)
  erg% = starte(adbasicfile$, linkadr%)
End Sub

Rem 2. Oft gebrauchte Funktionen zur Messung und Signalerzeugung
Rem ============================================================
'
Rem Einmaliges Messen des analogen Eingangs mit der Nummer "NADC%"
Rem der Mewert steht in den niedrigsten 12 Bits des Rckgabewerts
Function ADC (NADC%) As Integer
  id% = to_link(linkadr%, 1)
  id% = to_link(linkadr%, NADC%)
  ADC = from_link2(linkadr%)
End Function

Rem Fragt die momentane Auslastung des Transputers ab.
Rem Rckgabewert ist die Auslastung in Prozent.'
Function auslast () As Integer
  id% = to_link(linkadr%, 254)
  auslast = from_link2(linkadr%)
End Function

Rem Inhalt des FIFO lschen
Sub clear_fifo (FNo%)
  id% = to_link(linkadr%, 114)
  id% = to_link(linkadr%, FNo%)
End Sub

Rem Abfragen der digitalen Eingnge
Rem Die Eingnge stehen bitweise in einem 16-Bit-Wort'
Function Dig_In () As Integer
  id% = to_link(linkadr%, 3)
  Dig_In = from_link2(linkadr%)
End Function

Rem Rcklesen des auf den digitalen Ausgngen ausgegbenen Wertes
Function Dig_Out () As Integer
  id% = to_link(linkadr%, 5)
  Dig_Out = from_link2(linkadr%)
End Function

Rem Fragt den momentane freien Speicher des Transputers ab.
Rem Rckgabewert ist der freie Speicher in Byte.
Function freemem () As Long
  id% = to_link(linkadr%, 253)
  freemem = from_link4(linkadr%)
End Function

Rem Liest aus dem Integer Datensatz mit der Nummer "DNo%"
Rem "count&" Elemente (ab der Position "first&"
Sub get_data (DNo%, first&, count&, Dest())
  id% = to_link(linkadr%, 107)
  id% = to_link(linkadr%, DNo%)
  id% = to_link4(linkadr%, first&)
  id% = to_link4(linkadr%, count&)
  typ% = from_link(linkadr%)
  If typ% = 2 Then
    For i1& = 0 To (count& - 1)
      Dest(i1&) = from_link2(linkadr%)
    Next i1&
  ElseIf typ% = 4 Then
    For i1& = 0 To (count& - 1)
      Dest(i1&) = from_link4(linkadr%)
    Next i1&
  ElseIf typ% = 5 Then
    For i1& = 0 To (count& - 1)
      Dest(i1&) = from_linkf(linkadr%)
    Next i1&
  End If
End Sub

Rem Element/e aus einem ADbasic FIFO vom Transputer abholen
Sub get_fifo (FNo%, count&, Dest())
  id% = to_link(linkadr%, 110)
  id% = to_link(linkadr%, FNo%)
  id% = to_link4(linkadr%, count&)
  If from_link(linkadr%) > 2 Then
    For i1& = 0 To (count& - 1)
      Dest(i1&) = from_link4(linkadr%)
    Next i1&
  Else
    For i1& = 0 To (count& - 1)
      Dest(i1&) = from_link2(linkadr%)
    Next i1&
  End If
End Sub

Rem Anzahl der Elemente im FIFO ermitteln
Function get_fifo_count (FNo%) As Long
  id% = to_link(linkadr%, 112)
  id% = to_link(linkadr%, FNo%)
  get_fifo_count = from_link4(linkadr%)
End Function

Rem Anzahl der freien Positionen im FIFO ermitteln
Function get_fifo_empty (FNo%) As Long
  id% = to_link(linkadr%, 113)
  id% = to_link(linkadr%, FNo%)
  get_fifo_empty = from_link4(linkadr%)
End Function

Rem Liefert den Wert des ADbasic Float Parameters mit der Nummer: PNo%
Function get_fpar (PNo%) As Single
  id% = to_link(linkadr%, 38)
  id% = to_link2(linkadr%, PNo% + 1100)
  get_fpar = from_linkf(linkadr%)
End Function

Rem Liefert den Wert des Integer Parameters mit der Nummer "PNo%"
Function get_par (PNo%) As Long
  id% = to_link(linkadr%, 38)
  id% = to_link2(linkadr%, PNo% + 1000)
  get_par = from_link4(linkadr%)
End Function

Rem Ld den Treiber auf die ADwin-Karte
Rem Je nach Prozessor auf der ADwin-Karte wird eine der folgenden Treiberdateien bentigt:
Rem    T225 Prozessor -> btlfile$ = "adwin2.btl"
Rem    T400 Prozessor -> btlfile$ = "adwin4.btl"
Rem    T805 Prozessor -> btlfile$ = "adwin8.btl"
Rem Die Speichergre (size&) wird in hexadezimaler Schreibweise angegeben
Rem Beispiele: ADwin-Karte mit 1MB -> size& = 100000
Rem              "     "       4MB -> size& = 400000
Rem              "     "       8MB -> size& = 800000
Sub iserv (btlfile$, size&)
  erg% = iserver(btlfile$, linkadr%, size&)
End Sub

Rem Setzen des DACs Nr. "NDAC%" auf den Wert "iw%"
Rem Der auszugebende Wert mu in den niedrigsten 12 Bits von "iw%" stehen
Sub set_dac (NDAC%, iw%)
  id% = to_link(linkadr%, 2)
  id% = to_link(linkadr%, NDAC%)
  id% = to_link2(linkadr%, iw%)
End Sub

Rem Setzt in der Liste fr die zyklische Ausgabe fr den DAC-Nr. "NADC%"
Rem das Element Nummer "Nstep%" auf den Wert "iw%"
Sub Set_DAC_List (NDAC%, nstep%, iw%)
  id% = to_link(linkadr%, 36)
  id% = to_link(linkadr%, NDAC%)
  nst& = nstep%
  id% = to_link4(linkadr%, nst&)
  id% = to_link2(linkadr%, iw%)
End Sub

Rem Weist dem ADbasic Integer Datensatz mit der Nummer "DNo%" die
Rem 1. "count&" Elemente aus dem Visual-Basic Array
Rem "source()" zu
Sub set_data (DNo%, count&, source())
  id% = to_link(linkadr%, 105)
  id% = to_link(linkadr%, DNo%)
  id% = to_link4(linkadr%, count&)
  typ% = from_link(linkadr%)
  If typ% = 2 Then
    For i1& = 0 To (count& - 1)
      id% = to_link2(linkadr%, source(i1&))
    Next i1&
  ElseIf typ% = 4 Then
    For i1& = 0 To (count& - 1)
      id% = to_link4(linkadr%, source(i1&))
    Next i1&
  ElseIf typ% = 5 Then
    For i1& = 0 To (count& - 1)
      id% = to_linkf(linkadr%, source(i1&))
    Next i1&
  End If
End Sub

Rem gibt den Wert der in "iw%" steht auf die digitalen Ausgnge aus
Sub set_dig_out (iw%)
  id% = to_link(linkadr%, 4)
  id% = to_link2(linkadr%, iw%)
End Sub

Rem Einem ADbasic FIFO die Werte aus einem Array zuweisen
Sub set_fifo (FNo%, count&, source())
  id% = to_link(linkadr%, 111)
  id% = to_link(linkadr%, FNo%)
  id% = to_link4(linkadr%, count&)
  If from_link(linkadr%) > 2 Then
    For i1& = 0 To (count& - 1)
      id% = to_link4(linkadr%, source(i1&))
    Next i1&
  Else
    For i1& = 0 To (count& - 1)
      id% = to_link2(linkadr%, source(i1&))
    Next i1&
  End If
End Sub

Rem Setzt den ADbasic Float-Parameter mit der Nummer: PNo%
Rem auf den Wert: iw%
Sub set_fpar (PNo%, iw!)
  id% = to_link(linkadr%, 34)
  id% = to_link2(linkadr%, PNo% + 1100)
  id% = to_linkf(linkadr%, iw!)
End Sub

Rem Setzt den ADbasic Integer-Parameter mit der Nummer: PNo%
Rem auf den Wert: iw%
Sub set_par (PNo%, iw&)
  id% = to_link(linkadr%, 34)
  id% = to_link2(linkadr%, PNo% + 1000)
  id% = to_link4(linkadr%, iw&)
End Sub

Rem Erzeugt in der Augabeliste fr den DAC-Nr. "NDAC%" einen Dreieckverlauf
Rem mit "nsteps%" Schritten , dem minmalwert "imin%" und dem maximalwert
Rem "imax%", zur spteren zyklischen Ausgabe.
Sub set_signalform_dreieck (NDAC%, nsteps%, imin%, imax%)
  For i1% = 0 To (nsteps% / 2 - 1)
    id& = imax% - imin%
    ih& = i1% * 2
    nst& = nsteps%
    iw& = (ih& * id&) / nst&
    iws% = iw& + imin%
    Call Set_DAC_List(NDAC%, i1%, iws%)
    Call Set_DAC_List(NDAC%, (nsteps% - i1% - 1), iws%)
    Next i1%
End Sub

Rem Erzeugt in der Ausgabeliste fr den DAC-Nr. "NDAC%" eineansteigende Rampe Dreieckverlauf
Rem mit "nsteps%" Schritten , dem minmalwert "imin%" und dem maximalwert
Rem "imax%", zur spteren zyklischen Ausgabe.
Sub set_signalform_rampea (NDAC%, nsteps%, imin%, imax%)
  For i1% = 0 To (nsteps% - 1)
    id& = imax% - imin%
    ih& = i1%
    nst& = nsteps%
    iw& = (ih& * id&) / nst&
    iws% = iw& + imin%
    Call Set_DAC_List(NDAC%, i1%, iws%)
    Next i1%
End Sub

Rem Erzeugt in der Ausgabeliste fr den DAC-Nr. "NDAC%" eine abfallende Rampe
Rem mit "nsteps%" Schritten , dem minmalwert "imin%" und dem maximalwert
Rem "imax%", zur spteren zyklischen Ausgabe.
Sub set_signalform_rampef (NDAC%, nsteps%, imin%, imax%)
  For i1% = 0 To (nsteps% - 1)
    id& = imax% - imin%
    ih& = i1%
    nst& = nsteps%
    iw& = (ih& * id&) / nst&
    iws% = imax% - iw&
    Call Set_DAC_List(NDAC%, i1%, iws%)
    Next i1%
End Sub

Rem Erzeugt in der AUsgabeliste fr den DAC-Nr. "NDAC%" einen Sinusverlauf
Rem mit "nsteps%" Schritten , dem minmalwert "imin%" und dem maximalwert
Rem "imax%", zur spteren zyklischen Ausgabe.
Sub set_signalform_sinus (NDAC%, nsteps%, imin%, imax%)
  For i1% = 0 To (nsteps% - 1)
    iamp! = (imax% - imin%) / 2 - 1
    imitt! = (imax% + imin%) / 2
    fh1! = (i1% * 6.2832) / nsteps%
    si! = Sin(fh1!) * iamp!
    ih1% = si!
    Call Set_DAC_List(NDAC%, i1%, (imitt! + ih1%))
    Next i1%
End Sub

Rem Erzeugt in der AUsgabeliste fr den DAC-Nr. "NDAC%" einen Trapezverlauf
Rem mit "nsteps%" Schritten , dem minmalwert "imin%" und dem maximalwert
Rem "imax%", zur spteren zyklischen Ausgabe.
Sub set_signalform_trapez (NDAC%, nsteps%, imin%, imax%)
  For i1% = 0 To (nsteps% / 4 - 1)
    id& = imax% - imin%
    ih& = i1% * 4
    nst& = nsteps%
    iw& = (ih& * id&) / nst&
    iws% = iw& + imin%
    Call Set_DAC_List(NDAC%, i1%, iws%)
    Call Set_DAC_List(NDAC%, ((nsteps% * 3 / 4) - i1% - 1), iws%)
    Next i1%
  For i1% = 0 To (nsteps% / 4 - 1)
    Call Set_DAC_List(NDAC%, (i1% + nsteps% / 4), imax%)
    Call Set_DAC_List(NDAC%, (nsteps% - i1% - 1), imin%)
    Next i1%
End Sub

Rem Setzt den Parameter "Npar%"fr die zyklische I/O-Funktionen auf "iw&"
Rem Zuordnung der Parameternummer :
Rem    Parameter fr den Meprozess :
Rem      1   =   Delay zwischen den Messungen in Mikrosekunden
Rem      3   =   Anzahl der Messschritte in einem Messzyklus
Rem      4   =   Eingangs Auswahlregister (pro Eingang ein Bit setzen)
Rem      5   =   Triggermode   (0 = sofort messen,  1 = berschreiten,
Rem                             2 = unterschreiten, 3 = digital )
Rem      6   =   Triggerkanal
Rem      7   =   Triggerschwelle
Rem      8   =   Pretriggeranteil (in Mepunkten)
Rem      9   =   Mehrfachtrigger
Rem
Rem    Parameter fr den analogen Ausgabeprozess :
Rem      32 =    Delay zwischen den Ausgabepunkten in Mikrosekunden
Rem      34 =    Anzahl der Ausgabepunkte in einem Zyklus
Rem      35 =    Anzahl der auszugebenden Zyklen
Rem      36 =    Ausgangs-Auswahlregister (pro benutzten Ausgang ein Bit)
Rem
Rem    Parameter fr kombinierten Ein- und Ausgabeprozess :
Rem      64 =    Delay zwischen den Meunkten in Mikrosekunden
Rem      66 =    Anzahl der Mekte in einem Zyklus
Rem      67 =    Anzahl der Zyklen
Rem      68 =    Ausgangs-Auswahlregister (pro benutzten Ausgang ein Bit)
Rem      69 =    Eingangs Auswahlregister (pro Eingang ein Bit setzen)
Rem      70 =    Meart  (0 = ersetzen,   1= summiern,   2 = filtern )
Rem      71 =    Mefilter
Rem
Rem    Parameter fr den PID-Reglerprozess :
Rem     128 =   PID-Regler Sollwert
Rem     129 =   PID-Regler P-Konstante
Rem     130 =   PID-Regler T0
Rem     131 =   PID-Regler Td
Rem     132 =   PID-Regler Ti
Rem
Sub set_zykl_lpar (Npar%, iw&)
  id% = to_link(linkadr%, 34)
  id% = to_link2(linkadr%, Npar%)
  id% = to_link4(linkadr%, iw&)
End Sub

Rem Setzt den Parameter "Npar%"fr die zyklische I/o-Funktionen auf den Wert "iw&"
Rem Zuordnung der Parameternummer s. set_zykl_lpar
Rem Wie set_zykl_lpar nur mit 16 Wert weitergegeben werden immer 32 Bit
Sub set_zykl_par (Npar%, iw%)
  iwh& = iw%
  id% = to_link(linkadr%, 34)
  id% = to_link2(linkadr%, Npar%)
  id% = to_link4(linkadr%, iwh&)
End Sub

Rem Startet eine Zyklische Messung
Rem Erst aufrufen wenn alle Parameter richtig gesetzt sind.
Sub Start_Mess_Zykl ()
  id% = to_link(linkadr%, 32)
  id% = to_link(linkadr%, 1)
End Sub

Rem Startet eine Zyklische Ausgabe
Rem Erst aufrufen wenn alle Parameter und Ausgabelisten richtig gesetzt sind.
Sub Start_Out_Zykl ()
  id% = to_link(linkadr%, 32)
  id% = to_link(linkadr%, 8)
End Sub

Rem Startet einen Pid-Regler
Rem Erst aufrufen wenn alle Parameter richtig gesetzt sind.'
Sub Start_Pid ()
  id% = to_link(linkadr%, 32)
  id% = to_link(linkadr%, 32)
End Sub

Rem Startet den ADbasic Prozess mit der Nummer "PNo%"
Rem Priorittsfestlegung:   "Pri%"  Prioritt
Rem                           0       High
Rem                           1       Low
Sub Start_Proz (PNo%, Pri%)
  id% = to_link(linkadr%, 32)
  id% = to_link(linkadr%, 99 + 2 * PNo% + Pri%)
End Sub

Rem Bricht eine zyklische Messung ab.
Sub Stop_Mess_Zykl ()
  id% = to_link(linkadr%, 33)
  id% = to_link(linkadr%, 1)
End Sub

Rem Bricht eine zyklische Ausgabe ab.
Sub stop_out_zykl ()
  id% = to_link(linkadr%, 33)
  id% = to_link(linkadr%, 8)
End Sub

Rem Bricht eine zyklische Ausgabe ab
Sub Stop_Pid ()
  id% = to_link(linkadr%, 33)
  id% = to_link(linkadr%, 32)
End Sub

Rem Hlt den ADbasic Prozess mit der Nummer "PNo%" an
Sub Stop_Proz (PNo%)
  id% = to_link(linkadr%, 33)
  id% = to_link(linkadr%, 99 + 2 * PNo%)
End Sub

Rem Auslesen des zyklisch gemessenen Messpunkts Nr. "Nstep%" vom analogen
Rem Eingang Nr. "NADC%".
Function Zykl_Wert (NADC%, nstep%) As Integer
  id% = to_link(linkadr%, 42)
  id% = to_link(linkadr%, NADC%)
  nste& = nstep%
  id% = to_link4(linkadr%, nste&)
  Zykl_Wert = from_link2(linkadr%)
End Function

